#!/usr/bin/perl -w
use strict;



my $changeFile = 0;

my @argArray;
my $args = 0;

for my $arg (@ARGV){
  if ($arg eq "-change"){
    $changeFile = 1;
  }
  else {
    $args++;
    push @argArray, $arg;
  }
}

if ($args != 2){
  die "Usage [-change] regEx filename\n".
			"\teg. replaceit.perl \"/href=\\\"(\\d*.html)\\\"/foobar data = \\\$1/g\" index.html\n"
}

my $regEx = $argArray[0];
my $filename = $argArray[1];


my @lines = ();

open (my $file, "<$filename") || die ("Unable to read from $filename");

while (<$file>){
  my $line = $_;
  push @lines, $line;
}
close($file);

my $outFile;

if ($changeFile){
  open ($outFile, ">$filename") || die ("Unable to write to $filename");
}

my $fileModification = 0;
my $lineNumber = 0;
foreach my $line (@lines) {
  my $oldLine = $line;
	my $evalLine = "\$line =~ s$regEx";
	eval $evalLine;
  
  if (!($oldLine eq $line)){
    if (!$fileModification){
      $fileModification = 1;
      if ($changeFile){
        print "***** $filename has been changed *****\n";
      }
      else{
        print "***** $filename has NOT been changed *****\n";
      }
    }
    print "FROM $lineNumber: $oldLine  TO $lineNumber: $line";
  }
  if ($changeFile){
    print $outFile $line;
  }

  $lineNumber++;  
}

if ($changeFile){
  close($outFile);
}
